var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var slider_1 = require("ui/slider");
var dependency_observable_1 = require("ui/core/dependency-observable");
var proxy_1 = require("ui/core/proxy");
var color_1 = require("color");
var styling_1 = require("ui/styling");
var types_1 = require("utils/types");
function isValidTime(slider) {
    return true;
}
function isHourValid(value) {
    return types_1.isNumber(value) && value >= 0 && value <= 23;
}
function isMinuteValid(value) {
    return types_1.isNumber(value) && value >= 0 && value <= 59;
}
function onHourPropertyChanged(data) {
    var picker = data.object;
    if (isValidTime(picker)) {
        picker._setNativeTime();
    }
    else {
        throw new Error(getErrorMessage(picker, "Hour", data.newValue));
    }
}
function onMinutePropertyChanged(data) {
    var picker = data.object;
    if (isValidTime(picker)) {
        picker._setNativeTime();
    }
    else {
        throw new Error(getErrorMessage(picker, "Minute", data.newValue));
    }
}
function getErrorMessage(picker, propertyName, newValue) {
    return propertyName + " property value (" + toString(newValue) + ":" + toString(picker.minute) + ") is not valid.";
}
function toString(value) {
    return value < 10 ? "0" + value : "" + value;
}
var TimeIntervalSlider = (function (_super) {
    __extends(TimeIntervalSlider, _super);
    function TimeIntervalSlider() {
        _super.apply(this, arguments);
        this._nativePropertyChangePropogating = false;
    }
    Object.defineProperty(TimeIntervalSlider.prototype, "lineWidth", {
        get: function () {
            return this._getValue(TimeIntervalSlider.lineWidthProperty);
        },
        set: function (lineWidth) {
            this._setValue(TimeIntervalSlider.lineWidthProperty, lineWidth);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "cornerRadius", {
        get: function () {
            return this._getValue(TimeIntervalSlider.cornerRadiusProperty);
        },
        set: function (cornerRadius) {
            this._setValue(TimeIntervalSlider.cornerRadiusProperty, cornerRadius);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "strokeColor", {
        get: function () {
            return this._getValue(TimeIntervalSlider.strokeColorProperty);
        },
        set: function (strokeColor) {
            this._setValue(TimeIntervalSlider.strokeColorProperty, strokeColor);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "fillColor", {
        get: function () {
            return this._getValue(TimeIntervalSlider.fillColorProperty);
        },
        set: function (fillColor) {
            this._setValue(TimeIntervalSlider.fillColorProperty, fillColor);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "hour", {
        get: function () {
            return this._getValue(TimeIntervalSlider.hourProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.hourProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "minute", {
        get: function () {
            return this._getValue(TimeIntervalSlider.minuteProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.minuteProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "minHour", {
        get: function () {
            return this._getValue(TimeIntervalSlider.minHourProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.minHourProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "maxHour", {
        get: function () {
            return this._getValue(TimeIntervalSlider.maxHourProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.maxHourProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "minMinute", {
        get: function () {
            return this._getValue(TimeIntervalSlider.minMinuteProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.minMinuteProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeIntervalSlider.prototype, "maxMinute", {
        get: function () {
            return this._getValue(TimeIntervalSlider.maxMinuteProperty);
        },
        set: function (value) {
            this._setValue(TimeIntervalSlider.maxMinuteProperty, value);
        },
        enumerable: true,
        configurable: true
    });
    TimeIntervalSlider.prototype._setNativeTime = function () {
        if (this._nativePropertyChangePropogating) {
            return;
        }
        this.value = (this.hour * 2) + (this.minute < 30 ? 0 : 1);
    };
    TimeIntervalSlider.lineWidthProperty = new dependency_observable_1.Property("lineWidth", "TimeIntervalSlider", new proxy_1.PropertyMetadata(2));
    TimeIntervalSlider.cornerRadiusProperty = new dependency_observable_1.Property("cornerRadius", "TimeIntervalSlider", new proxy_1.PropertyMetadata(5));
    TimeIntervalSlider.fillColorProperty = new dependency_observable_1.Property("fillColor", "TimeIntervalSlider", new proxy_1.PropertyMetadata(new color_1.Color("gray"), dependency_observable_1.PropertyMetadataSettings.None, undefined, color_1.Color.isValid), styling_1.converters.colorConverter);
    TimeIntervalSlider.strokeColorProperty = new dependency_observable_1.Property("strokeColor", "TimeIntervalSlider", new proxy_1.PropertyMetadata(new color_1.Color("white"), dependency_observable_1.PropertyMetadataSettings.None, undefined, color_1.Color.isValid), styling_1.converters.colorConverter);
    TimeIntervalSlider.hourProperty = new dependency_observable_1.Property("hour", "TimeIntervalSlider", new proxy_1.PropertyMetadata(0, dependency_observable_1.PropertyMetadataSettings.None, onHourPropertyChanged, isHourValid));
    TimeIntervalSlider.minuteProperty = new dependency_observable_1.Property("minute", "TimeIntervalSlider", new proxy_1.PropertyMetadata(0, dependency_observable_1.PropertyMetadataSettings.None, onMinutePropertyChanged, isMinuteValid));
    TimeIntervalSlider.minHourProperty = new dependency_observable_1.Property("minHour", "TimeIntervalSlider", new proxy_1.PropertyMetadata(0, dependency_observable_1.PropertyMetadataSettings.None, onHourPropertyChanged, isHourValid));
    TimeIntervalSlider.maxHourProperty = new dependency_observable_1.Property("maxHour", "TimeIntervalSlider", new proxy_1.PropertyMetadata(2 * 23, dependency_observable_1.PropertyMetadataSettings.None, onHourPropertyChanged, isHourValid));
    TimeIntervalSlider.minMinuteProperty = new dependency_observable_1.Property("minMinute", "TimeIntervalSlider", new proxy_1.PropertyMetadata(0, dependency_observable_1.PropertyMetadataSettings.None, onMinutePropertyChanged, isMinuteValid));
    TimeIntervalSlider.maxMinuteProperty = new dependency_observable_1.Property("maxMinute", "TimeIntervalSlider", new proxy_1.PropertyMetadata(30, dependency_observable_1.PropertyMetadataSettings.None, onMinutePropertyChanged, isMinuteValid));
    return TimeIntervalSlider;
})(slider_1.Slider);
exports.TimeIntervalSlider = TimeIntervalSlider;
