var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var time_picker_slider_common_1 = require("./time-picker-slider-common");
var slider_1 = require("ui/slider");
function onWidthPropertyChanged(data) {
    var slider = data.object;
    slider.ios.lineWidth = data.newValue;
}
function onCornerRadiusPropertyChanged(data) {
    var slider = data.object;
    slider.ios.cornerRadius = data.newValue;
}
function onFillColorPropertyChanged(data) {
    var slider = data.object;
    slider.ios.fillColor = data.newValue.ios;
}
function onStrokeColorPropertyChanged(data) {
    var slider = data.object;
    slider.ios.strokeColor = data.newValue.ios;
}
time_picker_slider_common_1.TimeIntervalSlider.lineWidthProperty.metadata.onSetNativeValue = onWidthPropertyChanged;
time_picker_slider_common_1.TimeIntervalSlider.cornerRadiusProperty.metadata.onSetNativeValue = onCornerRadiusPropertyChanged;
time_picker_slider_common_1.TimeIntervalSlider.fillColorProperty.metadata.onSetNativeValue = onFillColorPropertyChanged;
time_picker_slider_common_1.TimeIntervalSlider.strokeColorProperty.metadata.onSetNativeValue = onStrokeColorPropertyChanged;
var TimeSliderChangeHandlerImpl = (function (_super) {
    __extends(TimeSliderChangeHandlerImpl, _super);
    function TimeSliderChangeHandlerImpl() {
        _super.apply(this, arguments);
    }
    TimeSliderChangeHandlerImpl.initWithOwner = function (owner) {
        var handler = TimeSliderChangeHandlerImpl.new();
        handler._owner = owner;
        return handler;
    };
    TimeSliderChangeHandlerImpl.prototype.sliderValueChanged = function (sender) {
        var owner = this._owner.get();
        if (owner) {
            var oldValue = owner.value;
            owner._onPropertyChangedFromNative(slider_1.Slider.valueProperty, sender.value);
            owner._nativePropertyChangePropogating = true;
            owner._onPropertyChangedFromNative(time_picker_slider_common_1.TimeIntervalSlider.hourProperty, Math.floor(sender.value / 2));
            owner._onPropertyChangedFromNative(time_picker_slider_common_1.TimeIntervalSlider.minuteProperty, 30 * (Math.floor(sender.value) % 2));
            owner._nativePropertyChangePropogating = false;
            if (!sender.tracking) {
                owner._onPropertyChanged(slider_1.Slider.valueProperty, sender.value, oldValue);
                if (sender.value < 2 * owner.minHour + (owner.minMinute < 30 ? 0 : 1)) {
                    sender.value = 2 * owner.minHour + (owner.minMinute < 30 ? 0 : 1);
                    this.sliderValueChanged(sender);
                }
                else if (sender.value > 2 * owner.maxHour + (owner.maxMinute < 30 ? 0 : 1)) {
                    sender.value = 2 * owner.maxHour + (owner.maxMinute < 30 ? 0 : 1);
                }
            }
        }
    };
    TimeSliderChangeHandlerImpl.ObjCExposedMethods = {
        'sliderValueChanged': { returns: interop.types.void, params: [HZTimeIntervalSlider] }
    };
    return TimeSliderChangeHandlerImpl;
})(NSObject);
var TimeIntervalSlider = (function (_super) {
    __extends(TimeIntervalSlider, _super);
    function TimeIntervalSlider() {
        _super.call(this);
        this._ios = new HZTimeIntervalSlider();
        this._changeHandler = TimeSliderChangeHandlerImpl.initWithOwner(new WeakRef(this));
        this._ios.addTargetActionForControlEvents(this._changeHandler, "sliderValueChanged", UIControlEvents.UIControlEventValueChanged);
    }
    Object.defineProperty(TimeIntervalSlider.prototype, "ios", {
        get: function () {
            return this._ios;
        },
        enumerable: true,
        configurable: true
    });
    return TimeIntervalSlider;
})(time_picker_slider_common_1.TimeIntervalSlider);
exports.TimeIntervalSlider = TimeIntervalSlider;
